/*******************************************************************************
 Autor: Ulli Sommer
 ACS (Anti Collisions System) mit Multithreading und I_Bumper
 Die Ausweichroutine ist so gestalltet, das ein festfahren
 in Ecken "fast" unmglich ist.
*******************************************************************************/

byte ACS_l, ACS_r, Drehung, Vorwaerts;
word I_Bumper_offset;

void main(void)
{

    PRO_BOT128_INIT();             //PRO-BOT128 Initialisieren
    DRIVE_ON();                    //Motor Treiber einschalten
    ENC_LED_ON();                  //Encoder IR LEDs einschalten
    ACS_INIT(2);                   //ACS setup / Sensity 1 To 20 (Anpassen)

    DELAY_MS(1000);                //1Sek. Pause
    BEEP(150,300);                 //Tonfolge
    BEEP(250,250);
    BEEP(150,300);

    ACS_r=1;                       //Werte auf vorwrts
    ACS_l=1;
    Vorwaerts=0;

    Thread_Start(1,Thread_ACS);    //Threads starten
    Thread_Start(2,Thread_Drive);
    Thread_Start(3,THREAD_I_BUMPER);


    //Hauptprogramm
    do
    {
        //Akku Unterspannungsberwachung
        if(AKKU_SPG()<4.3)
        {
           Thread_Delay(100);
           if(AKKU_SPG()<4.1)
           {
              Thread_Kill(1);
              Thread_Kill(2);
              DRIVE_OFF();
              ENC_LED_OFF();

              do
              {
                 BEEP(150,100);
                 Thread_Delay(100);
              }while(1);

           }
        }

    }while(1);

}


//Thread 1
void Thread_ACS(void)
{
   do
   {
      //ACS permanent einlesen
      ACS_l=ACS_LEFT();
      Thread_Delay(1);    //10ms
      ACS_r=ACS_RIGHT();
      Thread_Delay(1);
   }while(1);

}


//Thread 2
void Thread_Drive(void)
{
    do
    {
       //Autonom umherfahren und dabei Hindernisse
       //ber das ACS-System ausweichen
       start:

       //vorwrts
       if((ACS_l==1)&&(ACS_r==1))
       {
          Vorwaerts++;
          if(Vorwaerts>20)Drehung=0;
          FLL_OFF();
          FLR_OFF();
          DRIVE_FWD(200,0);
          goto start;
       }

       //rckwrts
       if((ACS_l==0)&&(ACS_r==0))
       {
          FLL_ON();
          FLR_ON();
          DRIVE_BWD(160,10);
          TURN_LEFT(135,3+Drehung);
          goto start;
       }

       //links drehen
       if((ACS_l==1)&&(ACS_r==0))
       {
          Drehung++;
          FLL_OFF();
          FLR_ON();
          TURN_LEFT(150,3+Drehung);
          goto start;
       }

       //rechts drehen
       if((ACS_l==0)&&(ACS_r==1))
       {
          Drehung++;
          FLL_ON();
          FLR_OFF();
          TURN_RIGHT(150,3+Drehung);
          goto start;
       }

    }while(1);

}


//Thread 3
void THREAD_I_BUMPER(void)
{
    //Bumper ber Betriebsspannugseinbruch

    //Spannungsoffset "Istwert bei normaler Fahrt"
    Thread_Delay(100);
    I_Bumper_offset=GET_ADC(0)-5;

    do
    {
      if(GET_ADC(0)<I_Bumper_offset)
      {
         Thread_Delay(50);
         if(GET_ADC(0)<I_Bumper_offset)
         {
            Thread_Kill(2);

            MOTOR_STOP();
            BEEP(150,200);

            FLL_ON();
            FLR_ON();

            DRIVE_BWD(150,10);

            TURN_LEFT(150,3+Drehung);

            DRIVE_FWD(200,5);

            //Offset neu einlesen
            I_Bumper_offset=GET_ADC(0)-5;
            Thread_Start(2,Thread_Drive);

            FLL_OFF();
            FLR_OFF();

         }
      }

      Thread_Delay(10);

    }while(1);

}
