/*******************************************************************************
 Autor: Ulli Sommer
 Multithreading mit den PRO-BOT128

 FLL = Front LED Left
 FLR = Front LED Right
 BLL = Back LED Left
 BLR = Back LED Right
*******************************************************************************/

#define FLL         19
#define FLR         18
#define BLL         17
#define BLR         16
#define LineLED     20
#define SW2         36


void main(void)
{

    //Wichtig: Sie mssen die Threads aktivieren!
    //Projekt\Optionen\Threads konfigurieren...

    Port_DataDirBit(FLL,PORT_OUT);
    Port_DataDirBit(FLR,PORT_OUT);
    Port_DataDirBit(BLL,PORT_OUT);
    Port_DataDirBit(BLR,PORT_OUT);

    Port_WriteBit(FLL,1);      //LED 1 ausschalten
    Port_WriteBit(FLR,1);      //LED 2 ausschalten
    Port_WriteBit(BLL,1);      //LED 3 ausschalten
    Port_WriteBit(BLR,1);      //LED 4 ausschalten

    Port_DataDirBit(SW2,0);    //Taster SW2 Input
    Port_WriteBit(SW2,1);      //Pullup einschalten


    //Endlosschleife
    do
    {
        press_sw2();            //Taster abfragen

        Thread_Start(1,blink1); //Thread 1 aktivieren
        press_sw2();
                                //.... usw.
        Thread_Start(2,blink2);
        press_sw2();

        Thread_Start(3,blink3);
        press_sw2();

        Thread_Start(4,blink4);
        press_sw2();

        //Jetzt bei jedem Druck auf SW2 die Threads nacheinander wieder beenden

        press_sw2();
        Thread_Kill(1);

        press_sw2();
        Thread_Kill(2);

        press_sw2();
        Thread_Kill(3);

        press_sw2();
        Thread_Kill(4);

        Thread_Delay(20);

    }while(1);

}



//Thread der nur LED1 blinken lsst
void blink1(void)
{
    //Jeder Thread hat seine eigene Endlosschleife!
    do
    {
        Port_WriteBit(FLL,0);
        Thread_Delay(25);
        Port_WriteBit(FLL,1);
        Thread_Delay(25);
    }while(1);
}


//Thread der nur LED2 blinken lsst
void blink2(void)
{
    do
    {
        Port_WriteBit(FLR,0);
        Thread_Delay(25);
        Port_WriteBit(FLR,1);
        Thread_Delay(25);
    }while(1);
}

//Thread der nur LED3 blinken lsst
void blink3(void)
{
    do
    {
        Port_WriteBit(BLL,0);
        Thread_Delay(25);
        Port_WriteBit(BLL,1);
        Thread_Delay(25);
    }while(1);
}

//Thread der nur LED4 blinken lsst
void blink4(void)
{
    do
    {
        Port_WriteBit(BLR,0);
        Thread_Delay(25);
        Port_WriteBit(BLR,1);
        Thread_Delay(25);
    }while(1);
}


//Taster abfragen
void press_sw2(void)
{
    int i;
    do
    {
         if(Port_ReadBit(SW2)==0)
         {
            Thread_Delay(5);
            if(Port_ReadBit(SW2)==0)
            {
               //Warten solange gedrckt...
               do
               {
               }while(Port_ReadBit(SW2)==0);
            }
            break;
         }
    }while(1);
}


