/*******************************************************************************
 Autor: Ulli Sommer
 PRO-BOT128 lsst sich ber eine RC5 Fernbedinung steuern
 Universalfernbedienung Conrad BN: 340720
 Code Nr.: CD / 0180
*******************************************************************************/

word RC5_Code, RC5_Tog_bit, RC5_Addr, RC5_Command, RC5_ExtCommand;
char Spacer[3];

void main(void)
{
    Spacer = ":";

    PRO_BOT128_INIT();     //PRO-BOT128 Initialisierung

    RC5_Init(26);          //PortBit TSOP1736

    AbsDelay(1000);        //Pause
    BLL_ON();              //Back LED left "ON"
    BLR_ON();              //Back LED right "ON"
    ENC_LED_ON();          //Encoder IR-LEDs "ON"
    DRIVE_ON();            //Motor "ON"

    BEEP(150,300);         //Tonfolge
    BEEP(250,250);
    BEEP(150,300);


    //Jetzt gehts los!
    do
    {
       //RC5 einlesen
       RC5_Code=RC5_Read();

       //Toggelbit auswerten 1 oder 0
       RC5_Tog_bit=RC5_Code & 0x800;
       if(RC5_Tog_bit!=0)
       {
          RC5_Tog_bit=1;
       }
       else
       {
          RC5_Tog_bit=0;
       }


       //Daten aufteilen
       RC5_Addr=((RC5_Code >> 6)) & 0x1f;
       RC5_Command=RC5_Code & 0x3F;
       RC5_ExtCommand=RC5_Command | ((RC5_Code & 0x1000) >> 6);

       //Debugausgabe (Start ber F10!)
       Msg_WriteWord(RC5_Tog_bit);
       Msg_WriteText(Spacer);
       Msg_WriteWord(RC5_Addr);
       Msg_WriteText(Spacer);
       Msg_WriteWord(RC5_Command);
       Msg_WriteText(Spacer);
       Msg_WriteWord(RC5_ExtCommand);
       Msg_WriteChar(13);

       //Meine Adresse = 20
       if(RC5_Addr==20)
       {
          switch(RC5_Command)
          {
                 //vorwrts
                 case 16:
                      FLL_ON();
                      FLR_ON();
                      BLL_OFF();
                      BLR_OFF();
                      DRIVE_FWD(180,0);
                      break;

                 //rckwrts
                 case 17:
                      FLL_OFF();
                      FLR_OFF();
                      BLL_ON();
                      BLR_ON();
                      DRIVE_BWD(180,0);
                      break;

                 //rechts drehen
                 case 22:
                      FLL_OFF();
                      FLR_ON();
                      BLL_OFF();
                      BLR_ON();
                      TURN_RIGHT(170,0);
                      break;

                 //links drehen
                 case 21:
                      FLL_ON();
                      BLL_ON();
                      FLR_OFF();
                      BLR_OFF();
                      TURN_LEFT(170,0);
                      break;

          }

       }

       if(RC5_Addr!=20)
       {
           //Stopp
           MOTOR_STOP();
           FLL_OFF();
           FLR_OFF();
           BLL_OFF();
           BLR_OFF();
       }


    }while(1);

}


