/*******************************************************************************
 Autor: Ulli Sommer
 Folge der Wand mit dem ACS-System
*******************************************************************************/

//ACS
#define PWM_IR 35
#define IR_left 27
#define IR_right 29
#define TSOP 26

//Rangefinder Parameter
#define TSOP_sensity 2
#define TSOP_increase 2
#define wall_dist 6

//Antriebs Deklaration
#define MFWD 3
#define MFLT 2
#define MOFF 1
#define MREV 0


int value, range_right, loop_cnt;
byte motl, motr;

void main(void)
{

    PRO_BOT128_INIT();
    DRIVE_ON();

    //IR-LEDs aus!
    Port_WriteBit(IR_left,PORT_OFF);
    Port_WriteBit(IR_right,PORT_OFF);

    //Tonfolge
    BEEP(250,300);
    BEEP(150,200);
    BEEP(250,300);

    //Antrieb auf vorwrts
    motr = MFWD;
    motl = MFWD;

    //Endlosschleife (Wandverfolgung)
    do
    {

        //Abstandswert holen
        value = RANGE_RIGHT();

        //Passt der Abstand zur Wand?
        if(value==wall_dist)
        {
           motr = MFWD;
           motl = MFWD;
        }

        //sanft rechts
        if((value > (wall_dist+1)) && (value != 255))
        {
           motr = MFLT;
           motl = MFWD;
        }

        //sanft links
        if((value < (wall_dist-1)) && (value != 255))
        {
           motr = MFWD;
           motl = MFLT;
        }

        //rechts drehen
        if((value > (wall_dist+2)) && (value != 255))
        {
           motr = MOFF;
           motl = MFWD;
        }

        //links drehen
        if((value < (wall_dist-2)) && (value != 255))
        {
           motr = MFWD;
           motl = MOFF;
        }

        //vorwrts fahren
        if(value==255)
        {
           motr = MFWD;
           motl = MFWD;
        }

        //Werte den Motoren bergeben
        switch(motr)
        {
               case MFWD:
                    Timer_T1PWB(220);
                    break;
               case MFLT:
                    Timer_T1PWB(190);
                    break;
               case MOFF:
                    Timer_T1PWB(128);
                    break;
               case MREV:
                    Timer_T1PWB(50);
                    break;
        }


        switch(motl)
        {
               case MFWD:
                    Timer_T1PWA(220);
                    break;
               case MFLT:
                    Timer_T1PWA(190);
                    break;
               case MOFF:
                    Timer_T1PWA(128);
                    break;
               case MREV:
                    Timer_T1PWA(50);
                    break;

        }

        //Regler Verzgerung
        DELAY_MS(100);

    }while(1);

}


int RANGE_RIGHT(void)
{
    int var;

    //Abszandsmessung mit den linken IR-Dioden!!!
    for(loop_cnt=0;loop_cnt<9;loop_cnt++)
    {
        //PWM neu stellen von ca. 28 bis 36Khz (51 = 36Khz)
        Timer_T3PWM(62-loop_cnt,TSOP_sensity+(loop_cnt/TSOP_increase),PS_8);

        //linke IR-LED ein
        Port_WriteBit(IR_left,PORT_OFF);
        Port_WriteBit(IR_right,PORT_ON);

        DELAY_MS(1);

        range_right = Port_ReadBit(TSOP);

        DELAY_MS(1);

        Port_WriteBit(IR_right,PORT_OFF); //aus
        Port_WriteBit(IR_left,PORT_OFF);

        DELAY_MS(1);

        //Ausgabe der Entfernung
        if(range_right==0)
        {
           var = loop_cnt;
           break;
        }

    }

    //objekt zuweit entfernt = 255
    if(range_right==1)
    {
       var = 255;
    }

    return var;

}

